import type { AbstractModelDB, Effect } from "@canvas-js/modeldb";
import { MessageId } from "./MessageId.js";
import { MessageSet } from "./MessageSet.js";
export type AncestorRecord = {
    key: Uint8Array;
    clock: number;
    links: Uint8Array;
};
export declare class AncestorIndex {
    private readonly db;
    static schema: {
        $ancestors: {
            $primary: "key/clock";
            key: "bytes";
            clock: "integer";
            links: "bytes";
        };
    };
    constructor(db: AbstractModelDB);
    private getLinks;
    isAncestor(messageId: MessageId, ancestorId: MessageId, visited: MessageSet): Promise<boolean>;
    indexAncestors(messageId: MessageId, parentIds: MessageSet, effects: Effect[]): Promise<void>;
    getAncestors(messageId: MessageId, atOrBefore: number, results?: MessageSet, visited?: MessageSet): Promise<MessageSet>;
}
