import type { Signature, Message } from "@canvas-js/interfaces";
import { MessageSet } from "./MessageSet.js";
export type MessageSourceType = "pubsub" | "push" | "sync";
export type MessageSource = {
    type: MessageSourceType;
    peer: string;
};
export type MessageContext<Result> = {
    source?: MessageSource;
    result?: Result;
};
export declare class SignedMessage<Payload = unknown, Result = any> {
    readonly signature: Signature;
    readonly message: Message<Payload>;
    readonly value: Uint8Array;
    readonly parents: MessageSet;
    static decode<Payload = unknown, Result = any>(value: Uint8Array, context?: MessageContext<Result>): SignedMessage<Payload, Result>;
    static encode<Payload, Result>({ codec, publicKey, signature }: Signature, message: Message<Payload>, context?: MessageContext<Result>): SignedMessage<Payload, Result>;
    readonly id: string;
    readonly key: Uint8Array;
    readonly source?: MessageSource;
    result?: Result;
    private constructor();
}
export declare function getNextClock(parents: MessageSet | string[] | Uint8Array[]): number;
