import { connect } from "it-ws/client";
import { Event } from "@canvas-js/gossiplog/protocols/events";
import { AbstractGossipLog } from "../AbstractGossipLog.js";
export declare const factory: import("@libp2p/interface").StreamMuxerFactory;
export declare class NetworkClient<Payload> {
    readonly gossipLog: AbstractGossipLog<Payload>;
    readonly addr: string;
    readonly log: import("@libp2p/logger").Logger;
    readonly pushProtocol: string;
    readonly syncProtocol: string;
    readonly muxer: ReturnType<typeof factory.createStreamMuxer>;
    readonly duplex: ReturnType<typeof connect>;
    readonly sourceURL: string;
    readonly eventSource: import("it-pushable").Pushable<Event, void, unknown>;
    error?: Error | unknown;
    constructor(gossipLog: AbstractGossipLog<Payload>, addr: string);
    private newStream;
    close(): Promise<void>;
    isConnected(): boolean;
    private push;
    private readonly handleMessage;
    private readonly handleProtocolStream;
    private eventSink;
    private handleInsertEvent;
    private handleUpdateEvent;
    private sync;
}
