import type { Node } from "@canvas-js/okra";
export declare class MissingParentError extends Error {
    readonly parent: string;
    readonly id: string;
    static code: string;
    readonly code: string;
    constructor(parent: string, id: string);
}
export declare class MessageNotFoundError extends Error {
    readonly id: string;
    static code: string;
    readonly code: string;
    constructor(id: string);
}
export declare class ConflictError extends Error {
    readonly source: Node;
    readonly target: Node;
    static code: string;
    readonly code: string;
    constructor(source: Node, target: Node);
}
export declare class AbortError extends Error {
    static code: string;
    readonly code: string;
    constructor();
}
