import { Message, Signature } from "@canvas-js/interfaces";
export type SignatureTuple = [codec: string, publicKey: string, signature: Uint8Array];
export type MessageTuple<Payload> = [
    signature: SignatureTuple,
    topic: string,
    clock: number,
    parents: Uint8Array[],
    payload: Payload
];
export declare function decodeSignedMessage(value: Uint8Array): {
    signature: Signature;
    message: Message;
};
export declare function encodeSignedMessage<Payload>({ codec, publicKey, signature }: Signature, { topic, clock, parents, payload }: Message<Payload>): Uint8Array;
export declare function getNextClock(parents: Uint8Array[]): number;
